#############################################################
#
# Phidget21 library
#
#############################################################
LIBPHIDGET_VERSION:=2.1.8.20140227
LIBPHIDGET_SOURCE:=libphidget_$(LIBPHIDGET_VERSION).tar.gz
LIBPHIDGET_SITE:=http://www.phidgets.com/downloads/libraries
LIBPHIDGET_INSTALL_STAGING = YES
LIBPHIDGET_INSTALL_TARGET = YES
LIBPHIDGET_DEPENDENCIES = libusb-compat
LIBPHIDGET_LIBTOOL_PATCH=NO

LIBPHIDGET_CONF_OPT = --enable-zeroconf=bonjour --enable-zeroconf-lookup

ifeq ($(BR2_PACKAGE_LIBPHIDGET_JAVA),y)
	LIBPHIDGET_CONF_OPT+= --enable-jni
else
	LIBPHIDGET_CONF_OPT+= --disable-jni
endif

$(eval $(call AUTOTARGETS,package,libphidget))

$(LIBPHIDGET_HOOK_POST_INSTALL): $(LIBPHIDGET_TARGET_INSTALL_TARGET)
ifeq ($(BR2_PACKAGE_UDEV),y)
	mkdir -p $(TARGET_DIR)/etc/udev/rules.d
	cp $(@D)/udev/99-phidgets.rules $(TARGET_DIR)/etc/udev/rules.d/
endif
ifeq ($(BR2_PACKAGE_LIBPHIDGET_JAVA),y)
	make -C $(@D) phidget21.jar
	mkdir -p $(TARGET_DIR)/usr/share/jamvm/endorsed
	cp -dpfr $(@D)/phidget21.jar $(TARGET_DIR)/usr/share/jamvm/endorsed
endif
	touch $@
