#############################################################
#
# luvcstats
#
#############################################################
LUVCSTATS_DESTDIR:=$(TARGET_DIR)/sbin
LUVCSTATS_SOURCE:=package/multimedia/luvcstats/src
LUVCSTATS_DIR:=$(BUILD_DIR)/luvcstats

$(LUVCSTATS_DIR)/.unpacked:
	mkdir -p $(LUVCSTATS_DIR)
	cp -r $(LUVCSTATS_SOURCE) $(LUVCSTATS_DIR)
	touch $@

$(LUVCSTATS_DIR)/.compiled: $(LUVCSTATS_DIR)/.unpacked
	$(MAKE) CC=$(TARGET_CC) -C $(LUVCSTATS_DIR)/src
	touch $@

$(LUVCSTATS_DESTDIR)/luvcstats: $(LUVCSTATS_DIR)/.compiled
	install -m 755 $(LUVCSTATS_DIR)/src/luvcstats $(LUVCSTATS_DESTDIR)/luvcstats
	$(STRIPCMD) $(STRIP_STRIP_ALL) $(LUVCSTATS_DESTDIR)/luvcstats

luvcstats: uclibc $(LUVCSTATS_DESTDIR)/luvcstats

luvcstats-source: $(LUVCSTATS_DIR)/.unpacked

luvcstats-clean:
	rm -rf $(LUVCSTATS_DESTDIR)/luvcstats
	-$(MAKE) -C $(LUVCSTATS_DIR)/src clean
	rm -f $(LUVCSTATS_DIR)/.compiled

luvcstats-dirclean:
	rm -rf $(LUVCSTATS_DIR)

.PHONY: luvcstats
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_LUVCSTATS)),y)
TARGETS+=luvcstats
endif
