#############################################################
#
# mjpg_streamer
#
#############################################################
MJPG_STREAMER_SVN_REV:=69
MJPG_STREAMER_SITE:=svn://svn.code.sf.net/p/mjpg-streamer/code
MJPG_STREAMER_CO_DIR:=$(BUILD_DIR)/mjpg-streamer
MJPG_STREAMER_DIR:=$(BUILD_DIR)/mjpg-streamer/mjpg-streamer/
MJPG_STREAMER_BINARY:=mjpg_streamer
MJPG_STREAMER_OUTPUT_PLUGIN:=output_http.so
MJPG_STREAMER_INPUT_PLUGIN:=input_uvc.so
MJPG_STREAMER_TARGET_BINARY:=usr/sbin/mjpg_streamer
MJPG_STREAMER_TARGET_OUTPUT_PLUGIN:=usr/lib/output_http.so
MJPG_STREAMER_TARGET_INPUT_PLUGIN:=usr/lib/input_uvc.so

$(MJPG_STREAMER_CO_DIR)/.source:
	svn co -r $(MJPG_STREAMER_SVN_REV) $(MJPG_STREAMER_SITE) $(MJPG_STREAMER_CO_DIR)
	toolchain/patch-kernel.sh $(MJPG_STREAMER_CO_DIR) package/multimedia/mjpg_streamer/ mjpg_streamer\*.patch
	touch $(MJPG_STREAMER_CO_DIR)/.source

$(MJPG_STREAMER_DIR)/$(MJPG_STREAMER_BINARY): $(MJPG_STREAMER_CO_DIR)/.source
	$(TARGET_CONFIGURE_OPTS) CFLAGS="$(TARGET_CFLAGS)" LDFLAGS="$(TARGET_LDFLAGS)" $(MAKE) -C $(MJPG_STREAMER_DIR)
   
$(TARGET_DIR)/$(MJPG_STREAMER_TARGET_BINARY): $(MJPG_STREAMER_DIR)/$(MJPG_STREAMER_BINARY)
	$(INSTALL) -m 0755 $(MJPG_STREAMER_DIR)/$(MJPG_STREAMER_BINARY) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_BINARY)
	$(INSTALL) -m 0644 $(MJPG_STREAMER_DIR)/$(MJPG_STREAMER_OUTPUT_PLUGIN) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_OUTPUT_PLUGIN)
	$(INSTALL) -m 0644 $(MJPG_STREAMER_DIR)/$(MJPG_STREAMER_INPUT_PLUGIN) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_INPUT_PLUGIN)
	$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_BINARY)
	$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_OUTPUT_PLUGIN)
	$(STRIPCMD) $(STRIP_STRIP_UNNEEDED) $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_INPUT_PLUGIN)

mjpg_streamer: uclibc $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_BINARY)

mjpg_streamer-clean:
	-$(MAKE) -C $(MJPG_STREAMER_DIR) clean
	@rm -f $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_BINARY)
	@rm -f $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_OUTPUT_PLUGIN)
	@rm -f $(TARGET_DIR)/$(MJPG_STREAMER_TARGET_INPUT_PLUGIN)

mjpg_streamer-dirclean:
	rm -rf $(MJPG_STREAMER_DIR)

#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_MJPG_STREAMER)),y)
TARGETS+=mjpg_streamer
endif
