#!/usr/bin/webif-page --upload-limit=5530
<?
. /usr/lib/webif/webif.sh
. /etc/config.sh

firmware_type=$( grep "type" /etc/phidgetsbc_version | awk '{print $2}' )

###################################################################
# user applications
#

############################
# Apps not supported on minimal
############################

if ! equal "$firmware_type" "full"; then
	header "Userspace" "Applications" "User applications" ''
	?>

User applications are not supported under the 'minimal' firmware.<br />
Please upgrade to a 'full' firmware to use user applications.<br /><br />
The upgrade page is here: <a href="/cgi-bin/webif/system-upgrade.sh">Upgrade</a>

	<?
else

############################
# header inject
############################
header_inject_head=$(cat <<EOF
<script defer type="text/javascript" src="/webif.js"></script>
<script type="text/javascript">
<!--
function webif_entityDecode(s) {
    var e = document.createElement("div");
    e.innerHTML = s;
    return e.firstChild.nodeValue;
}

var webif_printf=function() {
	var num = arguments.length;
	var output = arguments[0];
	for (var i = 1; i < num; i++) {
		var pattern = "\\\\{" + (i-1) + "\\\\}";
		var re = new RegExp(pattern, "g");
		output = output.replace(re, arguments[i]);
	}
	return output;
}

function printStatus() {
	document.write('<div style="display: none; font-size: 14pt; font-weight: bold;" id="status_text" />Uploading...&nbsp;</div>');
}

function statusupdate() {
	document.getElementById("form_submit").style.display = "none";
	document.getElementById("status_text").style.display = "inline";

	return true;
}

function confirm_delapp(path,file,appname) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}' application?", appname)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delapp=" + encodeURIComponent(file) + "&delapp_name=" + encodeURIComponent(appname);
	}
}

function confirm_deldir(path,file) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}' directory?", file)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delpath=" + encodeURIComponent(file);
	}
}
function confirm_delfile(path,file) {
	if (window.confirm(webif_entityDecode(webif_printf("WARNING!\\n\\nDo you really want to delete the '{0}/{1}' file?", path, file)))) {
		window.location="$SCRIPT_NAME?path=" + encodeURIComponent(path) + "&delfile=" + encodeURIComponent(file);
	}
}
-->
</script>

<style type="text/css">
<!--
#appbrowser table {
	margin-left: 1em;
	margin-right: 1em;
	margin-bottom: 2.2em;
	text-align: left;
	font-size: 0.8em;
	border-style: none;
	border-spacing: 0;
	border: thin solid black;
}
#appbrowser td {
	padding-left: 0.5em;
	padding-right: 1.0em;
}
#filebrowser table {
	margin-left: 1em;
	margin-right: 1em;
	margin-bottom: 2.2em;
	text-align: left;
	font-size: 0.8em;
	border-style: none;
	border-spacing: 0;
}
#filebrowser td {
	padding-left: 0.1em;
	padding-right: 0.1em;
}
#filebrowser td.number {
	text-align: right;
}
#filebrowser td.leftimage {
	padding-left: 0em;
}
#filebrowser td.image {
	text-align: center;
}
#filebrowser td.rightimage {
	padding-right: 0em;
}
#filebrowser a.tooltip {
	z-index: 3;
}
#filebrowser span.tooltip {
	display: none;
}
#filebrowser a:hover.tooltip {
	position: relative;
}
#filebrowser a:hover.tooltip span.tooltip {
	z-index: 5;
	display: block;
	position: absolute;
	top: 1.1em;
	left: 1.8em;
	width: 20em;
	text-decoration: none;
	padding: 3px;
	border: 1px solid;
	color: Black;
	background-color: White;
}
-->
</style>

EOF
)

############################
# delete handlers
############################
! empty "$FORM_delapp" && {
	load_settings ua_$FORM_delapp_name
	$SBC_CONFIGDIR/init.d/S$app_priority$FORM_delapp_name stop 2>&1 >/dev/null
	sleep 2
	cd / 2>/dev/null
	ERROR=$(rm -rf $FORM_delapp $SBC_CONFIGDIR/init.d/S??$FORM_delapp_name $SBC_CONFIGDIR/ua_$FORM_delapp_name.conf)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
Application was deleted successfully:<br/>
<strong>$FORM_delapp_name</strong><br/><br/>
EOF
)
	}
}
! empty "$FORM_delpath" && {
	cd / 2>/dev/null
	ERROR=$(rmdir "$FORM_delpath" 2>&1)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
Directory was deleted successfully:<br/>
<strong>$FORM_delpath</strong><br/><br/>
EOF
)
	}
}
! empty "$FORM_delfile" && {
	ERROR=$(rm "$FORM_path/$FORM_delfile" 2>&1)
	equal "$?" "0" && {
		MESSAGE=$(cat <<EOF
File was deleted successfully:<br/>
<strong>$FORM_path/$FORM_delfile</strong><br/><br/>
EOF
)
	}
}

############################
# path handling stuff
############################
! equal "$ERROR" "" && ERROR="$ERROR<br />"

FORM_path="${FORM_path:-/}"
ERROR="$ERROR$(cd "$FORM_path" 2>&1)"
cd "$FORM_path" 2>/dev/null
while [ "$?" != "0" ]; do
	FORM_path="${FORM_path%/*}"
	FORM_path="${FORM_path:-/}"
	cd "$FORM_path" 2>/dev/null
done
FORM_path="$(pwd)"

# don't travel outside of SBC_USERAPPS
if [ ! `expr substr $FORM_path 1 ${#SBC_USERAPPS}` = $SBC_USERAPPS ]; then
	FORM_path=$SBC_USERAPPS
	cd $FORM_path
fi

# return to the cgi dir
cd "${SCRIPT_NAME%/*}" 2>/dev/null

############################
# save stuff
############################
! empty "$SUCCESS" && echo "$SUCCESS"

edit_pathname="$FORM_path/$FORM_edit"
saved_filename="/tmp/.webif/edited-files$edit_pathname"

! empty "$FORM_save" && {
	SAVED=1
	mkdir -p "/tmp/.webif/edited-files$FORM_path"
	echo "$FORM_filecontent" > "$saved_filename"
}

! empty "$FORM_savecommit" && {
	rm -f "$saved_filename"
	MESSAGE="File was saved successfully:<br/><strong>$edit_pathname</strong>"
	echo "$FORM_filecontent" > "$edit_pathname"
}

empty "$FORM_cancel" || FORM_edit=""

###################################
# an application page - pre header
###################################
if ! equal "$FORM_path" "$SBC_USERAPPS" && empty "$FORM_edit" && empty "$FORM_view"; then

#might have to fill it in
if empty "$FORM_app" ; then
	FORM_app=${FORM_path#$SBC_USERAPPS/}
	FORM_app=${FORM_app%%/*}
fi

if ! exists $SBC_CONFIGDIR/ua_$FORM_app.conf; then
	MESSAGE="Warning - config file missing, recreating..."
	us_make_config_file $FORM_app
fi

load_settings ua_$FORM_app

if ! exists $SBC_CONFIGDIR/init.d/S$app_priority$app_name; then
	MESSAGE="Warning - startup file missing, recreating..."
	ua_make_startup_file $FORM_app
fi

if equal "$FORM_startstop" "Start"; then
	$SBC_CONFIGDIR/init.d/S$app_priority$app_name forcestart
	sleep 2
elif equal "$FORM_startstop" "Stop"; then
	$SBC_CONFIGDIR/init.d/S$app_priority$app_name stop
	sleep 2
fi

# config changes
if ! equal $FORM_config_change ""; then

	SAVED=1
	validate <<EOF
int|FORM_priority|Startup order|required min=10 max=99 cfg|$FORM_priority
string|FORM_args|Command Line Arguments|cfg|$FORM_args
EOF

	equal "$?" 0 && {

		save_setting ua_$FORM_app app_enabled "$FORM_enabled"
		save_setting ua_$FORM_app app_priority "$FORM_priority"
		save_setting ua_$FORM_app app_daemonize "$FORM_daemonize"
		save_setting ua_$FORM_app app_cmd "$FORM_command"
		save_setting ua_$FORM_app app_args "$FORM_args"
		mv $SBC_CONFIGDIR/init.d/S$FORM_old_priority$FORM_app $SBC_CONFIGDIR/init.d/S$FORM_priority$FORM_app
		
		if [ -f $SBC_USERAPPS/$app_name/$FORM_command ]; then
			chmod 755 $SBC_USERAPPS/$app_name/$FORM_command
		fi
	}
else
	FORM_enabled=$app_enabled
	FORM_priority=$app_priority
	FORM_daemonize=$app_daemonize
	FORM_command=$app_cmd
	FORM_args=$app_args
fi
fi


############################
# new app was created
############################
if ! equal "$FORM_newapp" ""; then
	validate <<EOF
hostname|FORM_newapp|Application Name|required min=1 max=63|$FORM_newapp
EOF
	if equal "$?" 0 ; then
		if [ -e $SBC_USERAPPS/$FORM_newapp ]; then
			ERROR="Error creating application: $FORM_newapp - an application of the same name already exists."
		else
			mkdir -p $SBC_USERAPPS/$FORM_newapp
			ua_make_config_file $FORM_newapp
			ua_make_startup_file $FORM_newapp
			MESSAGE="Created new application: $FORM_newapp"
		fi
	fi

fi

############################
# directory was created
############################
if ! equal "$FORM_dirname" ""; then

	SAVED=1
	validate <<EOF
filedir|FORM_dirname|Directory Name|required min=1 max=63|$FORM_dirname
EOF
	if equal "$?" 0 ; then
		SAVED=
		#strip any path info - just want the filename
		filename="${FORM_file_name##*\\}"
		filename="${filename##*/}"
		if [ -e "$FORM_path/$FORM_dirname" ]; then
			ERROR="Error creating directory $FORM_dirname - a file or directory of the same name already exists."
		else
			if mkdir "$FORM_path/$FORM_dirname"; then
				MESSAGE="Directory was created successfully:<br/><strong>$FORM_dirname</strong>"
			else
				ERROR="Error creating directory $FORM_dirname"
			fi
		fi
	fi
	
fi

############################
# file was uploaded
############################
if ! equal "$FORM_file" ""; then
	#strip any path info - just want the filename
	filename="${FORM_file_name##*\\\\}"
	filename="${filename##*/}"
	
	validate <<EOF
filedir|filename|File Name|required min=1 max=63|$filename
EOF

	if equal "$?" 0 ; then
		fsize=$(ls -alL "$FORM_file" 2>/dev/null | awk '{ print $5 }')
		freespace_bytes=$(df $SBC_USERSPACE | grep / | awk {'print $4*1024'})
		if [ "$fsize" -gt "$freespace_bytes" ]; then
			ERROR="Error recieving file $filename - not enough free space"
			rm "$FORM_file"
		elif [ -e "$FORM_path/$filename" ]; then
			ERROR="Error recieving file $filename - a file or directory of the same name already exists."
			rm "$FORM_file"
		else
			if mv "$FORM_file" "$FORM_path/$filename"; then
				MESSAGE="File was uploaded successfully:<br/><strong>$filename</strong>"
			else
				ERROR="Error recieving file $filename"
				rm "$FORM_file"
			fi
		fi
	else
		rm "$FORM_file"
	fi
fi

############################
# header
############################
	header "Userspace" "Applications" "User applications" ''
	
############################
# root apps
############################
if equal "$FORM_path" "$SBC_USERAPPS"; then

	odd=0
	freespace=$(df -h $SBC_USERSPACE | grep / | awk {'print $4'})
	
	cat <<EOF
<div class="settings">
<div class="settings-title"><h3><strong>User Applications</strong></h3></div>
<div class="settings-content">
<table width="100%" summary="Settings">
<tr><td>
EOF
	
	if [ "$( ls | awk 'END {print NR}' )" = "0" ]; then
		echo "No user applications are installed.<br /><br />"
	else
	
	cat <<EOF
Currently installed applications:<br /><br />
<div id="appbrowser">
<table>
EOF

	for app in $( ls $SBC_USERAPPS/ ) ; do
		app_path=$SBC_USERAPPS/$app
		size=$( du -sh $app_path | awk '{print $1}' )

		load_settings ua_$app
		equal "$app_enabled" "true" && enabled="<font color="green">Enabled</font>"
		equal "$app_enabled" "false" && enabled="<font color="red">Disabled</font>"
	
		app_file="$SBC_USERAPPS/$app_name/$app_cmd"

		if [ "${app_cmd##*\.}" = "class" ]; then
			run_app="jamvm ${app_cmd%\\.class}"
		elif [ "${app_cmd##*\.}" = "jar" ]; then
			run_app="jamvm -jar ${app_cmd%\\.jar}"
		else
			run_app="$app_file"
		fi

		running="<font color="red">Stopped</font>"
		ps | grep -v grep | grep -q "$run_app" && running="<font color="green">Running</font>"
		
		if equal "$odd" "1"; then
			echo "<tr class=\"odd\">"
			odd=0
		else
			echo "<tr>"
			odd=1
		fi


		cat <<EOF
<td>
<a href="$SCRIPT_NAME?app=$app&path=$app_path">$app</a>
</td>
<td align="right">$size</td>
<td align="right">$enabled</td>
<td align="right">$running</td>
<td align="right"><a href="javascript:confirm_delapp('${app_path%/$app}','$app_path','$app')"><img src="/images/action_x.gif" alt="Delete" /></a></td>
</tr>

EOF
	done

	cat <<EOF
</table>
</div>
EOF
	# end of app list
	fi

	cat <<EOF
<form name="new" action="$SCRIPT_NAME">
<input type="text" name="newapp">
<input type="submit" value="Create new app">
<input type="hidden" name="createnewapp" value="true">
</form>	
<br />
		
Free space remaining on userspace partition: $freespace
		</td></tr>
	</table>
	</div>
	<div class="settings-help"><blockquote><dl>
		<h4>Notes:</h4>
		<p>
Use this phidget21.jar for building Java applications, to ensure that your application is compatible with the installed library version: 
<a href="/cgi-bin/webif/download?script=$SCRIPT_NAME&amp;path=/usr/share/jamvm/endorsed&amp;savefile=phidget21.jar">phidget21.jar</a></p>
	</dl></blockquote></div><div style="clear: both">&nbsp;</div></div>

	


EOF

############################
# an application page
############################
elif empty "$FORM_edit" && empty "$FORM_view"; then

	cat <<EOF
<a href="$SCRIPT_NAME">Back to application list</a><br /><br />

<h3>'$FORM_app' Application page</h3>
EOF
	#start/stop controls
	app_file="$SBC_USERAPPS/$app_name/$app_cmd"
	
	if ! empty "$app_cmd"; then
		if [ "${app_cmd##*\.}" = "class" ]; then
			run_app="jamvm ${app_cmd%\\.class}"
		elif [ "${app_cmd##*\.}" = "jar" ]; then
			run_app="jamvm -jar ${app_cmd%\\.jar}"
		else
			run_app="$app_file"
		fi

		running="Stopped"
		ps | grep -v grep | grep -q "$run_app" && running="Running"
		
		if equal "$running" "Stopped"; then
			echo "<form method=\"post\" action=\"$SCRIPT_NAME\">Application is <font color=\"red\">stopped</font>... <input type=\"submit\" value=\"Start\" name=startstop />"
		else
			echo "<form method=\"post\" action=\"$SCRIPT_NAME\">Application is <font color=\"green\">running</font>... <input type=\"submit\" value=\"Stop\" name=startstop />"
		fi
		cat <<EOF
<input type="hidden" value="$FORM_path" name=path />
<input type="hidden" value="$FORM_app" name=app />
</form>
EOF
	fi
	
	#stdout/stderr
	if exists /tmp/$app_name/stdout; then
		cat <<EOF
view <a href="$SCRIPT_NAME?path=$FORM_path&view=/tmp/$app_name/stdout">stdout</a>, 
<a href="$SCRIPT_NAME?path=$FORM_path&view=/tmp/$app_name/stderr">stderr</a><br />
EOF
	fi
	echo "<br />"

############################
# File listing
############################

	app=${FORM_path#$SBC_USERAPPS/}


	(ls -alLe "$FORM_path" 2>/dev/null | sed '/^[^d]/d';
		ls -alLe "$FORM_path" 2>/dev/null | sed '/^[d]/d') 2>/dev/null | awk \
		-v url="$SCRIPT_NAME" \
		-v path="$FORM_path" \
		-f /usr/lib/webif/common.awk \
		-f /usr/lib/webif/browser.awk

	cat <<EOF
	<div class="settings">
	<form method="POST" name="upload" action="$SCRIPT_NAME" enctype="multipart/form-data" onSubmit="statusupdate()">
	<div class="settings-content">
	<table width="100%" summary="Settings">

		<tr>
			<td>Upload a new file:</td>
			<td>
				<input type="file" name="file" />
			</td>
		</tr>
		<tr>
			<td />
			<td>
				<script type="text/javascript">printStatus()</script>
				<input type="hidden" name="path" value="$FORM_path" />
				<input id="form_submit" type="submit" name="submit" value="Upload" onClick="statusupdate()" />

				<br />
				<br />
				</form>
			</td>
		</tr>
		<tr>
			<td>Create a directory:</td>
			<td>
				<form method="POST" name="newdir" action="$SCRIPT_NAME">
				<input type="hidden" name="path" value="$FORM_path" />
				<input type="text" name="dirname" />
			</td>
		</tr>
		<tr>
			<td />
			<td>
				<input id="form_submit2" type="submit" name="submit2" value="Create" />
				<br />
				<br />
				</form>
			</td>
		</tr>
	</table>
	</div>
	<div class="settings-help"><blockquote><dl>
		<h4>Notes:</h4>
		<p>Upload your compiled application files along with any required resources. 
		Supported program types are: ARM Binary and Java (class files or jar archive). Maximum file size is 4 MB.</p>
		<p>Java .class files that are part of a package must be uploaded into appropriate 
		package directories, which may be created from this interface. Java classes that
		are not part of a package and .jar files must be uploaded into the base directory.</p>
		<p>ARM binary files must be uploaded into the base directory.</p>
	</dl></blockquote></div><div style="clear: both">&nbsp;</div></div>
	<br/>
EOF

############################
# app settings
############################

command_list_create()
{
	echo -n '<select id="command" name="command">'
	for file in $( find $SBC_USERAPPS/$app_name -type f ); do
		file=${file#$SBC_USERAPPS/$app_name/}
		extenstion=${file#*\.}
		if [ "$extenstion" = "class" ]; then
			if ! echo "$file" | grep '\$[0-9]' >&- 2>&-; then
				name=${file%\.class}
				name=$( echo "$name" | sed 's|/|.|' )
				file="$name.class"
				if [ "$file" = "$FORM_command" ]; then
					echo -n "<option selected=\"selected\" value=\"$file\">$name</option>"
				else
					echo -n "<option value=\"$file\">$name</option>"
				fi
			fi
		else
			if ! echo "$file" | grep "/" >&- 2>&-; then
				name=$file
				if [ "$file" = "$FORM_command" ]; then
					echo -n "<option selected=\"selected\" value=\"$file\">$name</option>"
				else
					echo -n "<option value=\"$file\">$name</option>"
				fi
			fi
		fi
	done
	echo '</select>'
}

command_list=$( command_list_create )

echo "<form enctype=\"multipart/form-data\" action=\"$SCRIPT_NAME\" method=\"post\"><input type=\"hidden\" name=\"submit\" value=\"1\" />"
_savebutton="<div class=\"page-save\"><input type=\"submit\" name=\"action\" value=\"Save Changes\" /></div>"

display_form <<EOF
start_form|Application Settings
radio|enabled|$FORM_enabled|true|Enabled
radio|enabled|$FORM_enabled|false|Disabled
field|Startup order
text|priority|$FORM_priority
field|Run as daemon
checkbox|daemonize|$FORM_daemonize|true|Enabled
field|Executable/Class name
string|$command_list
field|Arguments
text|args|$FORM_args
hidden|path|$FORM_path
hidden|app|$FORM_app
hidden|config_change|true
hidden|old_priority|$FORM_priority
helpitem|Enabled
helptext|Enabled applications will start automatically when the SBC is booted. Disabled applications can be started manually by the user.
helpitem|Startup Order
helptext|Use to set the startup order when multiple applications are defined. Lower numbers get started first.
helpitem|Run as daemon
helptext|Runs the application as a daemon. This should only be disabled if the application daemonizes itself - otherwise the SBC startup proccess will hang.
helpitem|Executable/Class Name
helptext|Name of the program file or class to execute. All uploaded files are listed - .class/.jar files will be run using the Java VM, all other files are executed directly. .class files are listed by package name.
helpitem|Arguments
helptext|Argument list to pass to the program.
end_form
EOF

############################
# File viewer page
############################
elif ! empty "$FORM_view" ;then
	cat "$FORM_view" 2>/dev/null | awk \
		-v url="$SCRIPT_NAME" \
		-v path="$FORM_path" \
		-v file="${FORM_view##*/}" \
		-f /usr/lib/webif/common.awk \
		-f /usr/lib/webif/viewer.awk

############################
# File editor page
############################
else
	exists "$saved_filename" && {
		edit_filename="$saved_filename"
	} || {
		edit_filename="$edit_pathname"
	}
	cat "$edit_filename" 2>/dev/null | awk \
		-v url="$SCRIPT_NAME" \
		-v path="$FORM_path" \
		-v file="$FORM_edit" \
		-f /usr/lib/webif/common.awk \
		-f /usr/lib/webif/editor.awk
fi

fi

footer ?>
<!--
##WEBIF:name:Userspace:200:Applications
-->
