#!/usr/bin/webif-page
<? 
. /usr/lib/webif/webif.sh

load_settings wireless_network
wifi_lanconfig=$lanconfig
load_settings network

memtotal="$(awk '($1 == "MemTotal:") {print $2}' /proc/meminfo)"
memfree="$(awk '($1 == "MemFree:") {print $2}' /proc/meminfo)"

mempercentfree=$(expr $memfree "*" 100 / $memtotal)
mempercentused=$(expr 100 - $mempercentfree)

memtotal="$(awk 'BEGIN{ mem = 0 } ($1 == "MemTotal:") {mem += int($2) / 1024} END{printf("%.1f", mem)}' /proc/meminfo)"
memfree="$(awk 'BEGIN{ mem = 0 } ($1 == "MemFree:") {mem += int($2) / 1024} END{printf("%.1f", mem)}' /proc/meminfo)"
memused="$(awk 'BEGIN{ mem = 0 } ($1 == "MemTotal:") {mem += int($2) / 1024} ($1 == "MemFree:") {mem -= int($2) / 1024} END{printf("%.1f", mem)}' /proc/meminfo)"

filesystem_header="  Size      Used  Available  Use%"
rootfs_info="$(df -h / | awk 'NR == 2 { printf("%6s%10s%11s%6s", $2, $3, $4, $5) }')"
userspace_info="$(df -h $SBC_USERSPACE | awk 'NR == 2 { printf("%6s%10s%11s%6s", $2, $3, $4, $5) }')"

curr_dns="$(cat /etc/resolv.conf | grep "nameserver" | awk {'printf("%s<br />", $2)'})"

header "Status" "General" "General status"

cat <<EOF
<h3>Network</h3>
<table style="text-align: left; width: 90%" border="0">
<tr>
EOF

for iface in $( ifconfig -a|grep -E "eth|wlan" |cut -d" " -f1 ); do

curr_ipaddr="$(/sbin/ifconfig $iface | sed -n '/inet addr:/s/ *inet addr:\([[:digit:].]*\) .*/\1/p')"
curr_gateway="$(route | grep "^default.*UG.*$iface" | awk {'print $2'})"
curr_subnetmask="$(/sbin/ifconfig $iface | grep "Mask:" | cut -d: -f4)"
macaddr="$(/sbin/ifconfig $iface | grep HWaddr | cut -b39-)"

if [ -z $( /sbin/ifconfig $iface | grep UP ) ]; then
	updown=DOWN
else
	updown=UP
fi

if [ "$iface" = "eth0" ]; then
	mode=$lanconfig
else
	mode=$wifi_lanconfig
fi

if [ ! -z $( echo $iface | grep wlan ) ]; then
	lantype=wireless
	if [ "$updown" = "UP" ]; then
		# can be ASSOCIATING, SCANNING, COMPLETED, ASSOCIATED, 4WAY_HANDSHAKE
		wifi_state=$( /usr/sbin/wpa_cli -i$iface status | grep "^wpa_state=" | cut -d= -f2 )
		[ "$wifi_state" = "" ] && wifi_state=ERROR

		if [ "$wifi_state" = "COMPLETED" ]; then
			wifi_ssid=$( /usr/sbin/wpa_cli -i$iface status | grep "^ssid=" | cut -d= -f2 )
			wifi_seq=$( /usr/sbin/wpa_cli -i$iface status | grep "^key_mgmt=" | cut -d= -f2 )
			wifi_eap_state=$( /usr/sbin/wpa_cli -i$iface status | grep "^EAP state=" | cut -d= -f2 )
			equal "$wifi_seq" "NONE" && {
				wifi_cipher=$( /usr/sbin/wpa_cli -i$iface status | grep "^group_cipher=" | cut -d= -f2 )
				! empty "$wifi_cipher" && wifi_seq=$wifi_cipher
			}
		fi
	else
		wifi_state=DOWN
	fi
else
	lantype=wired
fi

cat <<EOF
<td valign="top">
<table style="text-align: left; border="0" cellpadding="2" cellspacing="2">
<tbody>
	<tr>
		<td style="width: 150px;">Adapter:</td>
		<td><pre>$iface ($updown)</pre></td>
	</tr>
	<tr>
		<td>Type:</td>
		<td><pre>$lantype</pre></td>
	</tr>
	<tr>
		<td>Mode:</td>
		<td><pre>$mode</pre></td>
	</tr>
	<tr>
		<td>IP Address:</td>
		<td><pre>$curr_ipaddr</pre></td>
	</tr>
	<tr>
		<td>Subnet Mask:</td>
		<td><pre>$curr_subnetmask</pre></td>
	</tr>
	<tr>
		<td>Gateway:</td>
		<td><pre>$curr_gateway</pre></td>
	</tr>
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>MAC Address:</td>
		<td><pre>$macaddr</pre></td>
	</tr>
EOF
if [ "$lantype" = "wireless" ]; then

cat <<EOF
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>Wireless State:</td>
		<td><pre>$wifi_state</pre></td>
	</tr>
EOF
	
	if [ "$wifi_eap_state" != "" ]; then

	cat <<EOF
	<tr>
		<td>EAP State:</td>
		<td><pre>$wifi_eap_state</td>
	</tr>
EOF

	fi
	
	if [ "$wifi_state" = "COMPLETED" ]; then

	cat <<EOF
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td>Wireless SSID:</td>
		<td><pre>$wifi_ssid</pre></td>
	</tr>
	<tr>
		<td>Wireless Security:</td>
		<td><pre>$wifi_seq</pre></td>
	</tr>
EOF
	fi

fi
cat <<EOF
</tbody>
</table>
</td>
EOF

done

cat <<EOF
</tr>
<tr>
<td>
<table style="text-align: left; border="0" cellpadding="2" cellspacing="2">
<tbody>
	<tr>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
	</tr>
	<tr>
		<td style="width: 150px;" valign="top">DNS Server(s):</td>
		<td><pre>$curr_dns</pre></td>
	</tr>
</tbody>
</table>
</td>
</tr>
</table>

<br /><br />

<h3>Filesystem</h3>
<table style="text-align: left; width: 90%" border="0" cellpadding="2" cellspacing="2">
<tbody>
	<tr>
		<td style="width: 150px;">&nbsp;</td>
		<td><pre>$filesystem_header</pre></td>
	</tr>
	<tr>
		<td>Root:</td>
		<td><pre>$rootfs_info</pre></td>
	</tr>
	<tr>
		<td>Userspace:</td>
		<td><pre>$userspace_info</pre></td>
	</tr>
EOF

df -h | awk 'BEGIN { mcount=0 };
	/media\/usb/ {
		filled_caption=$5;
		print "	<tr>"
		printf("		<td>%s:</td>", $6)
		printf("		<td><pre>%6s%10s%11s%6s</pre></td>", $2, $3, $4, $5)
		print "	</tr>"
	}'

cat <<EOF
</tbody>
</table>
<br />
<h3>Memory</h3>
<table style="text-align: left; width: 90%" border="0" cellpadding="2" cellspacing="2">
<tbody>
	<tr>
		<td style="width: 150px;">Total:</td>
		<td><pre>$memtotal M</pre></td>
	</tr>
	<tr>
		<td>Available:</td>
		<td><pre>$memfree M</pre></td>
	</tr>
</tbody>
</table>
EOF

footer 
?>


<!--
##WEBIF:name:Status:100:General
-->
