#!/usr/bin/webif-page
<?
. /usr/lib/webif/webif.sh
###################################################################
# status-processes.sh

header_inject_head=$(cat <<EOF

<style type="text/css">
<!--
#proctable table {
	margin-left: 1em;
	margin-right: 1em;
	margin-bottom: 1.5em;
	text-align: left;
	font-size: 0.8em;
	border-style: none;
	border-spacing: 0;
	border: thin solid black;
}
#proctable td, th {
	padding-left: 0.5em;
	padding-right: 1.0em;
}
-->
</style>

EOF

)

header "Status" "Processes" "@TR<<status_processes_Running_Processes#Running Processes>>"

echo "<div class=\"settings\">"

?>

<h3><strong>@TR<<status_processes_Processes_Status#Processes Status>></strong></h3>
<div id="proctable" class="proctable">
<table>
<tbody>
<?

proclist=$(echo -n "";ps)
echo "$proclist" | grep -v "[p]s " | awk '
BEGIN {
	odd=1
	tr_ind = ""
	td_ind = "\t"
}
function readcmdline(pid) {
	if (("/bin/cat /proc/" pid "/cmdline 2>/dev/null | tr \"\\0\" \" \"" | getline) > 0) return $0
	else return ""
}
{
	for (i=1; i<=NF; i++) {
		gsub(/^ */, "", $i)
		gsub(/ *$/, "", $i)
		gsub(/&/, "\\&amp;", $i)
		gsub(/</, "\\&lt;", $i)
		gsub(/>/, "\\&gt;", $i)
	}
	if ($1 == "PID") {
		print tr_ind "<tr>"
		print td_ind "<th>"$1"</th>"
		print td_ind "<th>"$2"</th>"
		print td_ind "<th>STATE</th>"
		print td_ind "<th>MEMORY</th>"
		print td_ind "<th>"$3"</th>"
		print tr_ind "</tr>"
	} else {
		if (odd == 1) {
			print tr_ind "<tr>"
			odd--
		} else {
			print tr_ind "<tr class=\"odd\">"
			odd++
		}
		
		printf td_ind "<td class=\"number\">" $1 "</td>"
		printf td_ind "<td>" $2 "</td>"

		pid = $1
		lcol = $3
		for (i=4; i<=NF; i++) lcol = lcol " " $i
		if (length(lcol) >= 50) {
			fulcmd = readcmdline($1)
			if (fulcmd) lcol = fulcmd
		}
		
		if(("/bin/cat /proc/" pid "/status | grep \"State:\"" | getline) > 0) state = $2
		else state = ""
		
		printf td_ind "<td>" state "</td>"
		
		if(("/bin/cat /proc/" pid "/status | grep \"VmSize:\"" | getline) > 0) mem = $2
		else mem = ""
		
		printf td_ind "<td>" mem "</td>"
		
		print td_ind "<td>" lcol "</td>"
		print tr_ind "</tr>"
	}
}
'

display_form <<EOF
string|</tbody>
end_form
EOF

# help
	cat <<EOF
<a name="pslegend"></a>
<h4>@TR<<status_processes_Legend#Legend>>:</h4>
<p>
Memory sizes are in kB units.<br />
State meanings: A=Active, I=Idle (waiting for startup), O=Nonexistent, R=Running, S=Sleeping, T=Stopped, W=Swapped, Z=Canceled.<br />
Identical commands are often threads of the same process.<br />
Commands enclosed in &quot;[...]&quot; are kernel threads.<br />
</p>
EOF


footer ?>
<!--
##WEBIF:name:Status:300:Processes
-->
