#!/usr/bin/webif-page "-U /tmp -u 8000"
<?
. /usr/lib/webif/webif.sh
. /etc/config.sh

board_string=$(awk '/^Hardware/ {print $3}' < /proc/cpuinfo)
board_string="$board_string $(awk '/^Revision/ {print $3}' < /proc/cpuinfo)"
board_string="$board_string $(dmesg | awk '/^CPU / {print $2}')"

system_hostname=$(hostname)

header "System" "Backup &amp; Restore" "<img src=\"/images/bkup.jpg\" alt=\"@TR<<Backup and Restore>>\" />&nbsp;@TR<<Backup and Restore>>" ''

DOWNLOAD()
{
cat <<EOF
&nbsp;&nbsp;&nbsp;@TR<<confman_noauto_click#If downloading does not start automatically, click here>> ... <a href="/$1">$2</a><br /><br />
<script language="JavaScript" type="text/javascript">
setTimeout('top.location.href=\"/$1\"',"300")
</script>
EOF
}

# Create a new backup for the user
if ! equal $FORM_download "" ; then
	
	
	tmp=/tmp/config.$$
	tgz=/tmp/phidgetsbc_backup.tgz
	rm -rf $tmp 2>/dev/null
	mkdir -p $tmp 2>/dev/null
	date > $tmp/config.date
	echo "$FORM_name" > $tmp/config.name

	echo $board_string > $tmp/config.boardtype
	
	if equal $FORM_backup_type "all" ; then
		[ -e $SBC_USERSPACE ] && {
			mkdir -p $tmp$SBC_USERSPACE
			cp -a $SBC_USERSPACE/* $tmp$SBC_USERSPACE/ 2>/dev/null
		}
		echo "everything" > $tmp/config.backuptype
	else
		echo "config" > $tmp/config.backuptype
	fi
	
	# always backup config
	[ -e $SBC_CONFIGDIR ] && {
		mkdir -p $tmp$SBC_CONFIGDIR
		cp -a $SBC_CONFIGDIR/* $tmp$SBC_CONFIGDIR/ 2>/dev/null
	}
	
	(cd $tmp; tar czf $tgz *)
	rm -rf $tmp 2>/dev/null
	DOWNLOAD "cgi-bin/webif/download?script=$SCRIPT_NAME&path=/tmp&savefile=phidgetsbc_backup.tgz" phidgetsbc_backup.tgz
	sleep 25 ; rm $tgz
	

# Restore a config
elif ! equal $FORM_instconfig "" ; then

	dir=$FORM_dir
	display_form <<EOF
start_form|@TR<<Restore Configuration>>
EOF
	if [ -n "$dir" ] && [ -d "$dir" ] && [ -e "$dir/config.name" ] && [ -e "$dir/config.boardtype" ] && [ -e "$dir/config.backuptype" ]; then
			echo "<tr><td colspan=\"2\">@TR<<confman_restoring_conf#Restoring configuration.>><br /><pre>"
			cd $dir
			
			if equal $(cat $dir/config.backuptype) "config" ; then
				COPY_DIR=${SBC_CONFIGDIR#/}
			else
				COPY_DIR=${SBC_USERSPACE#/}
			fi
			
			find $COPY_DIR | while read -r file
			do
			#for file in $(find $COPY_DIR); do
				if [ -d "$file" ]; then
					[ -d /"$file" ] || mkdir /"$file"
				else
					[ -e /"$file" ] && rm /"$file"
					cp "$file" /"$file"
					echo "restoring $file"
				fi
			done

		echo "<br />Rebooting now...<meta http-equiv=\"refresh\" content=\"1;url=reboot.sh?reboot=1\">"
		echo "</pre></td></tr>"
	else
		echo "<p>@TR<<confman_bad_dir#bad dir>>: $dir</p>"
	fi

	display_form <<EOF
end_form
EOF

# Check a config
elif ! equal $FORM_chkconfig "" ; then

	if [ -n "$FORM_configfile" ] && [ -e "$FORM_configfile" ]; then
			
		echo "<form method=\"get\" name=\"install\" action=\"$SCRIPT_NAME\">"
		display_form <<EOF
start_form|@TR<<Restore Configuration>>
EOF
		rm -rf /tmp/config.* 2>/dev/null
		tmp=/tmp/config.$$
		mkdir $tmp
		(cd $tmp; tar xzf $FORM_configfile)
		rm $FORM_configfile

		if [ ! -e "$tmp/config.name" ] || [ ! -e "$tmp/config.boardtype" ]; then
			echo "<tr><td colspan=\"2\">@TR<<confman_invalid_file#Invalid file>>: phidgetsbc_backup.tgz!</td></tr>"
		else
			nm=$(cat $tmp/config.name)
			bd=$(cat $tmp/config.boardtype)
			dt=$(cat $tmp/config.date)
			bt=$(cat $tmp/config.backuptype)

			CFGGOOD="<tr><td colspan=\"2\">@TR<<confman_good_conf#The configuration looks good>>!<br /><br /></td></tr>"

			if [ "$bd" != "$board_string" ]; then
				echo "<tr><td colspan=\"2\"><font color=\"red\">@TR<<big_warning#WARNING>></font>: @TR<<confman_other_board#different board type>> (@TR<<confman_board_ours#ours>>: $board_string, @TR<<confman_board_file#file>>: $bd)!</td></tr>"
			else
				echo $CFGGOOD
			fi
			display_form <<EOF
field|@TR<<Config Name>>
string|$nm
field|@TR<<Board Type>>
string|$bd
field|@TR<<Generated>>
string|$dt
field|@TR<<Backup Type>>
string|$bt
field
EOF
			echo "</td></tr>"
		fi

		cat <<EOF
<tr><td>&nbsp;</td></tr>
<tr><td><input type='hidden' name='dir' value="$tmp" />
<input type="submit" name="instconfig" value="@TR<<Restore>>" /></td></tr>
<tr><td>&nbsp;</td></tr>
EOF

		display_form <<EOF
end_form
EOF
		echo "</form>"
	fi

# system reset
elif ! equal $FORM_reset "" ; then

	cat <<EOF
	<form method="post" name="systemreset" action="$SCRIPT_NAME">
		Confirm: Really reset the system now?
		<input type="submit" name="reset_confirmed" value="Reset" />
	</form>
EOF

# system reset confirmed
elif ! equal $FORM_reset_confirmed "" ; then

		set_mtd userspace
		echo "Erasing userspace partition ($mtd) ... <br /><br />"
		phidgetnand erase -q $mtd
				
		echo "<br />Rebooting now...<meta http-equiv=\"refresh\" content=\"1;url=reboot.sh?reboot=1\">"
# Main page
else
	cat <<EOF
	<form method="post" name="download" action="$SCRIPT_NAME" enctype="multipart/form-data">
EOF

	display_form <<EOF
start_form|Backup System
field|Backup:
radio|backup_type|config|config|Configuration
radio|backup_type|config|all|Everything
field|Name this configuration:
text|name|${FORM_name:-$system_hostname}
field|<br />
field|
string|<input type="submit" name="download" value="Backup" />
helpitem|Backup
helptext|Configuration backup backs up all configuration files. This includes network, passwords, system settings, etc. Everything backup backs up the configuration data as well as user applications and the user and root home directories.
helpitem|Name
helptext|You can give the backup file an arbitrary name. This will be shown during restore.
end_form
EOF

	display_form <<EOF
start_form|Restore Configuration
field|Saved backup file:
upload|configfile
field|<br />
field|
string|<input type="submit" name="chkconfig" value="Restore" />
helpitem|Notes
helptext|Choose a backup file for this machine type. The restore system will check the file and ask for confirmation before running the restore.
end_form
EOF

	display_form <<EOF
start_form|Reset System
string|<input type="submit" name="reset" value="Reset" />
helpitem|Notes
helptext|This will reset the system to its default state. This includes resetting all configuration files, as well as deleting all custom applications and files in userspace. This will not restore a broken kernel or root filesystem, which can only be achieved by a hard reset.
end_form
EOF

	echo "</form>"
fi

footer
?>
<!--
##WEBIF:name:System:450:Backup &amp; Restore
-->
