#!/usr/bin/webif-page -p /bin/sh
. /usr/lib/webif/webif.sh

#/usr/bin/webif-page -p /bin/sh

# NOTE: this is not using haserl at all - we're manually interpreting data

timeout=45
remotefirmwaredir="http://www.phidgets.com/downloads/sbc"
remotefirmwarelist="http://www.phidgets.com/downloads/sbc/index.php?action=list"
kernel_file=uImage
filesystem_file=rootfs.arm.jffs2

# Make sure we are connected to this page with ethernet link if possible
#Don't do this yet - it seems to got over wifi anyways...
#if ! empty $( /sbin/ifconfig eth0 | grep UP ); then
#	router_ip="$(/sbin/ifconfig eth0 | sed -n '/inet addr:/s/ *inet addr:\([[:digit:].]*\) .*/\1/p')"
#	referer_ip="${HTTP_REFERER#http://}"
#	referer_ip="${referer_ip%%/*}"
#	if ! equal "$router_ip" "$referer_ip" && ! empty $referer_ip; then
#		eth0_addr="http://$router_ip$SCRIPT_NAME"
#		header_inject_head="<meta http-equiv=\"refresh\" content=\"0;$eth0_addr\" />"
#	fi
#fi

# Will refresh to main page after timeout seconds
# Tries to get the hostname that the user is using, falls back on eth0 or wlan0 IP address
equal "$REQUEST_METHOD" "POST" && {
	referer_ip="${HTTP_REFERER#http://}"
	referer_ip="${referer_ip%%/*}"
	if empty "$referer_ip"; then
		for ipaddr in $(/sbin/ifconfig | sed -n '/inet addr:/s/ *inet addr:\([[:digit:].]*\) .*/\1/p'); do
			if ! empty "$ipaddr" && ! equal "$ipaddr" "127.0.0.1"; then
				router_ip="$ipaddr"
				break
			fi
		done
	else
		router_ip="$referer_ip"
	fi
	if ! empty "$router_ip"; then
		header_inject_head="<meta http-equiv=\"refresh\" content=\"$timeout; url=http://$router_ip/\" />"
	fi
}

header "System" "Upgrade" "<img src=/images/upd.jpg align=absmiddle>&nbsp;Firmware Upgrade"

#####################################################################
do_upgrade() {
	echo "<br />Upgrading firmware ... <br /><br />"

	# free some memory :) - this lists everything not to kill
	ps | awk '$3 !~ /(Command)|(init)|(httpd)|(haserl)|(bin\/sh)|(awk)|(kill)|(^ps)|(webif)|(mdnsd)|(watchdog)|(\[)(wpa)/ { print $1 }' | xargs kill -KILL

	MEMFREE="$(awk 'BEGIN{ mem = 0 } ($1 == "MemFree:") || ($1 == "Cached:") {mem += int($2)} END{print mem}' /proc/meminfo)"

	if [ $(($MEMFREE)) -ge 51200 ]; then
		mount -o remount,size=50m /tmp
		
		cp /usr/bin/simplereboot /tmp/

		rm -f /tmp/$kernel_file
		rm -f /tmp/$filesystem_file

		# Get new firmware here
		if equal "$UPGRADE_METHOD" "upload"; then
			bstrip "$BOUNDARY" | tar -x -f - -C /tmp
		elif equal "$UPGRADE_METHOD" "download"; then
			echo "Downloading $FIRMWARE from Phidgets Inc. This may take a while depending on your connection...<br /><br />"
			mkfifo /tmp/wget_pipe
			( wget $remotefirmwaredir/$FIRMWARE -O - 2>/tmp/wget_pipe | tar -x -f - -C /tmp ) &
			( cat /tmp/wget_pipe -u | tr '\015' '\n' | awk 'BEGIN{ bigp=10 } /%/ { p=int(substr($2,1,index($2,"%")-1)); if (p < bigp) print "."; else {print p "%<br />";bigp+=10;}}' ) &
			wait
			rm /tmp/wget_pipe
			echo "<br />"
			FILENAME="$FIRMWARE"
		elif equal "$UPGRADE_METHOD" "usb"; then
			echo "Copying $FIRMWARE into memory...<br /><br />"
			( cd /tmp; tar -xf $FIRMWARE )
			FILENAME="$FIRMWARE"
		fi

		# Write new firmware here
		if exists /tmp/$kernel_file && exists /tmp/$filesystem_file; then
			echo "$FILENAME received successfully.<br /><br />"
			
			# Erase userspace here - only after properly getting firmware
			if equal "$erase_userspace" "true"; then
				set_mtd userspace
				echo "Erasing userspace partition ($mtd) ... <br /><br />"
				phidgetnand erase -q $mtd
			fi
			
			echo "Writing kernel to flash ... <br /><br />"
			set_mtd kernel
			if ! phidgetnand write -e -q -p $mtd /tmp/$kernel_file; then
				echo "Error: problem writing kernel<br />"
			fi
			echo "Writing filesystem to flash ... <br /><br />"
			set_mtd rootfs
			#This actually overwrites the filesystem, then reboots - this can mess up the webif since the page never finishes loading..
			if ! phidgetnand write -e -q $mtd /tmp/$filesystem_file; then
				echo "Error: problem writing filesystem<br />"
			else
				cat <<EOF
Rebooting ... <br /><br />
Please wait 45 seconds. The PhidgetSBC configuration should automatically reload.<br /><br />
</div>
	</div> <!-- End #content -->

	<br />
	<fieldset id="save">
	<legend><strong>Proceed Changes</strong></legend>
	
	<ul class="apply"><li>&nbsp;</li><li>&nbsp;</li><li>&nbsp;</li></ul>
	</fieldset>
	
	<hr />
	<div id="footer">
		<h3>Phidgets Inc.</h3>
	</div>
</div> <!-- End #container -->
</body>
</html>
EOF
				/tmp/simplereboot
				exit
			fi
		else
			echo "Error: Problem getting firmware. Please try again.<br />"
		fi
	else
		echo "Error: not enough room to store firmware, reboot and try again, or reset and try again.<br />"
		if equal "$UPGRADE_METHOD" "upload"; then
			bstrip "$BOUNDARY" > /dev/null
		fi
		return
	fi
}

#####################################################################
read_var() {
	NAME=""
	while :; do
		read -r LINE
		# remove single character that's not number or letter... why? - \r maybe?
		LINE="${LINE%%[^0-9A-Za-z]}"
		equal "$LINE" "$BOUNDARY" && read -r LINE
		empty "$NAME$LINE" && return
		case "${LINE%%:*}" in
			Content-Disposition)
				NAME="${LINE##*; name=\"}"
				NAME="${NAME%%\"*}"
				FILENAME="${LINE##*; filename=\"}"
				FILENAME="${FILENAME%\"*}"
				#strip any path info - just want the filename
				FILENAME=${FILENAME##*\\}
				FILENAME=${FILENAME##*/}
			;;
		esac
		empty "$LINE" && return
	done 
}

#####################################################################
NOINPUT=1

#####################################################################
equal "$REQUEST_METHOD" "GET" && {

	usb_firmwares=$( (cd /media; find -maxdepth 2) | grep -E "phidgetsbc-(full|minimal).[0-9]\.[0-9]\.[0-9]\.[0-9]*\.bin" | sed 's/^\./\/media/' )
	
	if ! nslookup www.phidgets.com 2>/dev/null 1>/dev/null; then
		download_firmware=false
	fi
	
	if [ -z $( /sbin/ifconfig eth0 | grep UP ) ]; then
		cat <<EOF
<font color="Red">Warning:</font> eth0 appears to be DOWN. System upgrades over wifi are not recommended, and may fail.<br /><br />
EOF
	fi

	cat <<EOF
	<script type="text/javascript">

function choseUpload()
{
	document.getElementById("upload_select").style.display = "";
EOF
	if ! equal "$download_firmware" "false"; then
		echo 'document.getElementById("download_select").style.display = "none";'
	fi
	if ! empty "$usb_firmwares"; then
		echo 'document.getElementById("usb_select").style.display = "none";'
	fi
	cat <<EOF
}

function choseDownload()
{
	document.getElementById("upload_select").style.display = "none";
EOF
	if ! equal "$download_firmware" "false"; then
		echo 'document.getElementById("download_select").style.display = "";'
	fi
	if ! empty "$usb_firmwares"; then
		echo 'document.getElementById("usb_select").style.display = "none";'
	fi
	cat <<EOF
}

function choseUSB()
{
	document.getElementById("upload_select").style.display = "none";
EOF
	if ! equal "$download_firmware" "false"; then
		echo 'document.getElementById("download_select").style.display = "none";'
	fi
	if ! empty "$usb_firmwares"; then
		echo 'document.getElementById("usb_select").style.display = "";'
	fi
	cat <<EOF
}

function statusupdate() {
	document.getElementById("form_submit").style.display = "none";
	document.getElementById("status_text").style.display = "inline";

	return true;
}
function printStatus() {
	document.write('<div style="display: none; font-size: 14pt; font-weight: bold;" id="status_text" />Upgrading...</div>');
}
	</script>
	<form method="POST" name="upgrade" action="$SCRIPT_NAME" enctype="multipart/form-data" onSubmit="statusupdate()">
	<div class="settings-title"><h3><strong>Firmware Upgrade</strong></h3></div>
	<div class="settings-content">
	<table width="100%">
	<tbody>
		<tr>
			<td colspan="2">
				<br /><input type="checkbox" name="erase_userspace" value="true" /> Erase Userspace partition and configuration data?<br /><br />
			</td>
		</tr>
		<tr>
			<td valign="top">Method:</td>
			<td>
EOF
	if ! empty "$usb_firmwares"; then
		echo '<input type="radio" name="method" value="download" onClick="choseDownload()" onChange="choseDownload()"> Download from Phidgets Inc.<br />'
		echo '<input type="radio" name="method" value="upload" onClick="choseUpload()" onChange="choseUpload()"> File upload'
		echo '<input type="radio" name="method" value="usb" onClick="choseUSB()" checked="true" onChange="choseUSB()"> USB Drive'
	elif equal "$download_firmware" "false"; then
		echo '<input type="radio" name="method" value="upload" checked="true" onClick="choseUpload()" onChange="choseUpload()"> File upload'
	else
		echo '<input type="radio" name="method" value="download" checked="true" onClick="choseDownload()" onChange="choseDownload()"> Download from Phidgets Inc.<br />'
		echo '<input type="radio" name="method" value="upload" onClick="choseUpload()" onChange="choseUpload()"> File upload'
	fi
	cat <<EOF
			</td>
		</tr>
EOF
	if equal "$download_firmware" "false"; then
		echo '<tr id="upload_select">'
	else
		echo '<tr id="upload_select" style="display: none;">'
	fi

	cat <<EOF
			<td>Firmware:</td>
			<td>
				<input type="file" name="firmware_upload" />
			</td>
		</tr>
EOF
	if ! equal "$download_firmware" "false"; then
	
		if ! empty "$usb_firmwares"; then
			echo '<tr id="download_select" style="display: none;">'
		else
			echo '<tr id="download_select">'
		fi
		cat <<EOF
				<td>Firmware:</td>
				<td>
EOF
		echo '<select name="firmware_download">'

		selected=" selected=\"selected\""
		for firmware in $(wget -q $remotefirmwarelist -O - 2>&-); do
			filesize=${firmware##*,}
			filename=${firmware%,*}
			cat <<EOF
						<option value="$filename"$selected>$filename - ($filesize MB)</option>
EOF
			selected=""
		done

		cat <<EOF
					</select>
				</td>
			</tr>
EOF
	fi
	
	if ! empty "$usb_firmwares"; then
		cat <<EOF
		<tr id="usb_select">
			<td>Firmware:</td>
			<td>
				<select name="firmware_usb">
EOF
	selected=" selected=\"selected\""
	for firmware in $usb_firmwares; do
		filesize=$( ls -lh $firmware | awk '{print $5}' )
		filename=${firmware##*/}
		cat <<EOF
					<option value="$firmware"$selected>$filename - ($filesize MB)</option>
EOF
		selected=""
	done

	cat <<EOF
				</select>
			</td>
		</tr>
EOF
	fi
	cat <<EOF
		<tr>
			<td>
				<br /><script type="text/javascript">printStatus()</script>
				<input id="form_submit" type="submit" name="submit" value="Upgrade" onClick="statusupdate()" />
			</td>
		</tr>
	</tbody>
	</table>
	</div>
<div class="settings-help"><blockquote><dl><h4>Notes:</h4><p>Upgrading should generally be done when the SBC is connected via ethernet.
		Upgrading over wifi may fail - especially if the 'full' firmware is selected - because of the slow link speed.</p>
		<p>The 'Download from Phidgets Inc.' option requires a high speed internet connection to the SBC. If the SBC is
		not connected to the internet, or connected with a low speed connection, download the file from Phidgets Inc. 
		first, and use the 'File Upload' option. The 'Download from Phidgets Inc.' will not appear if the SBC cannot connect to phidgets.com</p>
		<p>The 'full' firmware contains all elements of the 'minimal' firmare as well as: on-board C development tools, 
		Java support, and custom user application support.</p>
		<p>Firmware can also be upgraded from a USB drive. This option will show up automatically when a USB drive
		with a suitable firmware file in it's root directory is attached.</p></dl></blockquote></div>
	</form>
EOF

}
#####################################################################
equal "$REQUEST_METHOD" "POST" && {
	equal "${CONTENT_TYPE%%;*}" "multipart/form-data" || ERR=1
	BOUNDARY="${CONTENT_TYPE##*boundary=}"
	empty "$BOUNDARY" && ERR=1

	empty "$ERR" || {
		echo "Wrong data format"
		footer
		exit
	}
cat <<EOF
	<div style="margin: auto; text-align: left">
EOF
	while :; do
		read_var
		if empty "$NAME" ; then
			break
		fi
		case "$NAME" in
			erase_userspace)
				read LINE
				erase_userspace=true
				;;
			method)
				read LINE
				UPGRADE_METHOD="${LINE%%[^0-9A-Za-z]}"
				;;
			firmware_upload)
				if equal "$UPGRADE_METHOD" "upload"; then
					if equal "$FILENAME" ""; then
						echo "Error: no file selected!<br />"
					else
						do_upgrade
					fi
				else
					read LINE
				fi
				;;
			firmware_download)
				read LINE
				FIRMWARE="${LINE%%[^0-9A-Za-z]}"
				if equal "$UPGRADE_METHOD" "download" ; then
					do_upgrade
				fi
				;;
			firmware_usb)
				read LINE
				FIRMWARE="${LINE%%[^0-9A-Za-z]}"
				if equal "$UPGRADE_METHOD" "usb" ; then
					do_upgrade
				fi
				;;
		esac
	done
cat <<EOF
</pre>
	</div>
EOF
}

footer

##WEBIF:name:System:900:Upgrade
