#############################################################
#
# webif
#
#############################################################
WEBIF_VERSION:=0.2
WEBIF_SOURCE:=package/webif
WEBIF_SITE:=https://svn.openwrt.org/openwrt/tags/whiterussian_0.9/package/webif
WEBIF_DIR:=$(BUILD_DIR)/webif-$(WEBIF_VERSION)

$(WEBIF_DIR)/.unpacked:
	mkdir -p $(WEBIF_DIR)
	touch $@

$(WEBIF_DIR)/.built: $(WEBIF_DIR)/.unpacked
	$(TARGET_CC) $(TARGET_CFLAGS) -o $(WEBIF_DIR)/webif-page $(WEBIF_SOURCE)/src/webif-page.c
	$(TARGET_CC) $(TARGET_CFLAGS) -o $(WEBIF_DIR)/bstrip $(WEBIF_SOURCE)/src/bstrip.c
	$(TARGET_CC) $(TARGET_CFLAGS) -o $(WEBIF_DIR)/simplereboot $(WEBIF_SOURCE)/src/simplereboot.c
	$(TARGET_CC) $(TARGET_CFLAGS) -lphidget21 -lm -lpthread -o $(WEBIF_DIR)/phidgetlist $(WEBIF_SOURCE)/src/phidgetlist.c
	$(TARGET_CC) $(TARGET_CFLAGS) -lphidget21 -lm -lpthread -o $(WEBIF_DIR)/phidget21version $(WEBIF_SOURCE)/src/phidget21version.c
	$(STRIPCMD) --strip-unneeded $(WEBIF_DIR)/webif-page $(WEBIF_DIR)/bstrip $(WEBIF_DIR)/phidgetlist $(WEBIF_DIR)/simplereboot
	touch $@

$(TARGET_DIR)/www/webif.js: $(WEBIF_DIR)/.built
	mkdir -p $(TARGET_DIR)/etc
	mkdir -p $(TARGET_DIR)/usr/bin
	mkdir -p $(TARGET_DIR)/usr/lib
	mkdir -p $(TARGET_DIR)/usr/lib/webif
	mkdir -p $(TARGET_DIR)/www
	mkdir -p $(TARGET_DIR)/www/images
	mkdir -p $(TARGET_DIR)/www/images/phidgets
	mkdir -p $(TARGET_DIR)/www/js
	mkdir -p $(TARGET_DIR)/www/webcam
	mkdir -p $(TARGET_DIR)/www/css
	mkdir -p $(TARGET_DIR)/www/cgi-bin
	mkdir -p $(TARGET_DIR)/www/cgi-bin/webif
	cp -dpfr $(WEBIF_SOURCE)/files/usr/lib/webif/*.sh $(TARGET_DIR)/usr/lib/webif
	cp -dpfr $(WEBIF_SOURCE)/files/usr/lib/webif/*.awk $(TARGET_DIR)/usr/lib/webif
	cp -dpfr $(WEBIF_SOURCE)/files/usr/lib/webif/*.csv $(TARGET_DIR)/usr/lib/webif
ifneq ($(strip $(BR2_PACKAGE_WEBIF_LANGUAGES)),y)
	rm -rf $(TARGET_DIR)/usr/lib/webif/lang
endif
	$(INSTALL) -m0755 $(WEBIF_DIR)/webif-page $(TARGET_DIR)/usr/bin/
	$(INSTALL) -m0755 $(WEBIF_DIR)/bstrip $(TARGET_DIR)/usr/bin/
	$(INSTALL) -m0755 $(WEBIF_DIR)/simplereboot $(TARGET_DIR)/usr/bin/
	$(INSTALL) -m0755 $(WEBIF_DIR)/phidgetlist $(TARGET_DIR)/usr/bin/
	$(INSTALL) -m0755 $(WEBIF_DIR)/phidget21version $(TARGET_DIR)/usr/bin/
ifeq ($(strip $(BR2_PHIDGETSBC_RELEASE_FULL)),y)
	$(INSTALL) -m0755 $(WEBIF_SOURCE)/files/usr/bin/createapp $(TARGET_DIR)/usr/bin/
endif
ifeq ($(strip $(BR2_PACKAGE_WEBIF_INSTALL_INDEX_HTML)),y)
	@if [ -f "$(TARGET_DIR)/www/index.html" ]; then			\
		echo;							\
		echo "webif WARNING:";					\
		echo "There is already a $(TARGET_DIR)/www/index.html";	\
		echo "webif might be replacing another package;"	\
		echo;							\
		echo "Sleeping for 10 seconds";				\
		sleep 10;						\
	fi
	cp -dpf $(WEBIF_SOURCE)/files/www/index.html $(TARGET_DIR)/www/
endif
	cp -dpfr $(WEBIF_SOURCE)/files/www/webif.js $(TARGET_DIR)/www/
	cp -dpfr $(WEBIF_SOURCE)/files/www/favicon.ico $(TARGET_DIR)/www/
	cp -dpfr $(WEBIF_SOURCE)/files/www/css/*.* $(TARGET_DIR)/www/css
	cp -dpfr $(WEBIF_SOURCE)/files/www/js/*.* $(TARGET_DIR)/www/js
	cp -dpfr $(WEBIF_SOURCE)/files/www/images/*.* $(TARGET_DIR)/www/images
	cp -dpfr $(WEBIF_SOURCE)/files/www/images/phidgets/*.* $(TARGET_DIR)/www/images/phidgets
	cp -dpfr $(WEBIF_SOURCE)/files/www/cgi-bin/webif/download $(TARGET_DIR)/www/cgi-bin/webif
	cp -dpfr $(WEBIF_SOURCE)/files/www/cgi-bin/webif/*.sh $(TARGET_DIR)/www/cgi-bin/webif
	cp -dpfr $(WEBIF_SOURCE)/files/www/webcam/*.* $(TARGET_DIR)/www/webcam
	cp -dpfr $(WEBIF_SOURCE)/files/www/cgi-bin/webif/.categories $(TARGET_DIR)/www/cgi-bin/webif
	@if [ ! -f $(TARGET_DIR)/etc/banner ]; then	\
		ln -sf issue $(TARGET_DIR)/etc/banner;	\
	fi
	touch $@

webif: busybox $(TARGET_DIR)/www/webif.js

webif-clean:
	rm -f $(TARGET_DIR)/www/cgi-bin/webif/* $(TARGET_DIR)/www/webif.*
	rm -rf $(TARGET_DIR)/usr/lib/webif
	rm -f $(TARGET_DIR)/usr/bin/bstrip $(TARGET_DIR)/usr/bin/webif-page $(TARGET_DIR)/usr/bin/simplereboot
	rm -f $(TARGET_DIR)/usr/bin/phidgetlist $(TARGET_DIR)/usr/bin/phidget21version
	rm -f $(WEBIF_DIR)/bstrip $(WEBIF_DIR)/webif-page $(WEBIF_DIR)/simplereboot $(WEBIF_DIR)/phidgetlist $(WEBIF_DIR)/phidget21version $(WEBIF_DIR)/.built

webif-source:

webif-dirclean:
	rm -rf $(WEBIF_DIR)
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_WEBIF)),y)
TARGETS+=webif
endif
