PATH=/usr/bin:/bin:/usr/sbin:/sbin

libdir=/usr/lib/webif
wwwdir=/www
cgidir=/www/cgi-bin
rootdir=/cgi-bin
indexpage=status-system.sh

. $libdir/functions.sh

#######################################################
# beginpage
#######################################################
beginpage() {
	cat <<EOF
Content-Type: text/html; charset=UTF-8
Pragma: no-cache

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title>PhidgetSBC Configuration</title>
  <link rel="stylesheet" type="text/css" href="/css/webif.css" />
  <link rel="stylesheet" type="text/css" href="/css/waitbox.css" media="screen" />
  <!--[if lt IE 7.]>
    <script defer type="text/javascript" src="/js/pngfix.js"></script>
  <![endif]-->
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
  <meta http-equiv="expires" content="-1" />
$header_inject_head
</head>
<body>
$header_inject_body
EOF
}

#######################################################
# begincontent
#######################################################
begincontent() {
	cat <<EOF
  <div id="content">
    <table width="100%" border="0" cellspacing="0" cellpadding="2">
      <tr valign="top">
        <td>
          <table width="100%" border="0" cellpadding="10" cellspacing="0">
            <tr>
              <td>

EOF
}

#######################################################
# footer
#######################################################
footer() {
	cat <<EOF

<!-- END PAGE SPECIFIC SECTION -->

$_savebutton
EOF
	equal "$didheader" "1" && {
		cat <<EOF

                    </td>
                  </tr>
                </table>
EOF
	}
	cat <<EOF
              </td>
            </tr>
          </table>
        </td>
      </tr>
    </table>
  </div> <!-- End #content -->
$_endform
  <div id="pagefooter">
    <span> &copy; 2010 by <a title="www.phidgets.com" href="http://www.phidgets.com" target="_blank">Phidgets Inc.</a> All rights reserved.</span>
  </div>
</body>
</html>
EOF
}

#######################################################
# messagebox
#######################################################
messagebox() {
	# These can live alone
	! empty "$ERROR" || ! empty "$MESSAGE" || ! empty "$AUTH_MESSAGE" && {
		cat <<EOF
                <div id="infobox">
                  <table border="0" cellspacing="0" cellpadding="4" width="100%">
                    <tr>
                      <td class="icon" align="center" valign="top"><img src="../images/exclam.gif" alt="" /></td>
                      <td class="message">
EOF

		! empty "$ERROR" && {
			echo "                        <p><font color=\"#E7292C\">Error(s)</font></p>"
			echo "                        <p class="failed-validation">$ERROR</p><br />"
		}
		! empty "$MESSAGE" && {
			echo "                        <p>$MESSAGE</p>"
		}
		! empty "$AUTH_MESSAGE" && {
			echo "                        <p>$AUTH_MESSAGE</p>"
		}
		
		cat <<EOF
                      </td>
                    </tr>
                  </table>
                </div>
EOF
	}
}

#######################################################
# header
#	Displays the page header and menus. Also sets up a
#	FORM surround if needed.
# Arguments:
#	1: Page title
#	2: Form action (generally $SCRIPT_NAME)
#######################################################
header() {
	_uptime="$(uptime)"
	_loadavg="${_uptime#*load average: }"
	_uptime="${_uptime#*up }"
	_uptime="${_uptime%%,*}"
	_hostname=$(cat /proc/sys/kernel/hostname)
	_board_version="$(cat /proc/cpuinfo | awk '/^Revision/ {print ("0x"$3)+0}')"
	_head="${1:+                <p class=\"pgtitle\">$1</p>}"
	_form="${2:+  <form enctype=\"multipart/form-data\" action=\"$2\" method=\"post\"><input type=\"hidden\" name=\"submit\" value=\"1\" />}"
	_savebutton="${4:+                <script type=\"text/javascript\" src=\"/js/waitbox.js\"></script><div class=\"page-save\"><input type=\"submit\" name=\"action\" value=\"Save Changes\" onClick=\"showLightbox(this);\" /></div>}"
	_space="${_savebutton:+                <br />}"
	_endform="${_savebutton:+  </form>}"
	
	beginpage
	cat <<EOF
  <div id="header">
    <br />
    <h1 valign="center">PhidgetSBC Recovery System</h1>
    <div id="header-picture">
      <img src="/images/phidgets/1072_0_Thumbnail.png" valign="center" />
    </div>
    <div id="short-status">
      <ul>
        <li><strong>Host Name:</strong> $_hostname</li>
        <li><strong>Uptime:</strong> $_uptime</li>
        <li><strong>Load:</strong> $_loadavg</li>
        <li><strong>Version:</strong> $_board_version</li>
      </ul>
    </div>
  </div>
  
EOF
	! empty "$_form" && echo "$_form"
	begincontent
	! empty "$_head" && echo "$_head"
	! empty "$_subtitle" && echo "$_subtitle"
	messagebox
	
	cat <<EOF
                <table width="100%" border="0" cellpadding="0" cellspacing="0">
                  <tr>
                    <td class="tabcont">
					  
<!-- BEGIN PAGE SPECIFIC SECTION -->

EOF
	didheader=1
}
# end of header

#######################################################
# display_form
#######################################################
display_form() {
	if empty "$1"; then
		awk -F'|' -f $libdir/common.awk -f $libdir/form.awk
	else
		echo "$1" | awk -F'|' -f $libdir/common.awk -f $libdir/form.awk
	fi
}

#######################################################
# list_remove
#######################################################
list_remove() {
	echo "$1 " | awk '
BEGIN {
	RS=" "
	FS=":"
}
($0 !~ /^'"$2"'/) && ($0 != "") {
	printf " " $0
	first = 0
}'
}

#######################################################
# handle_list
#######################################################
handle_list() {
	# $1 - remove
	# $2 - add
	# $3 - submit
	# $4 - validate
	
	empty "$1" || {
		LISTVAL="$(list_remove "$LISTVAL" "$1") "
		LISTVAL="${LISTVAL# }"
		LISTVAL="${LISTVAL%% }"
		_changed=1
	}
	
	empty "$3" || {
		validate "${4:-none}|$2" && {
			if empty "$LISTVAL"; then
				LISTVAL="$2"
			else
				LISTVAL="$LISTVAL $2"
			fi
			_changed=1
		}
	}

	LISTVAL="${LISTVAL# }"
	LISTVAL="${LISTVAL%% }"
	LISTVAL="${LISTVAL:- }"

	if empty "$_changed"; then
		return 255
	else
		return 0
	fi
}
