/*
 * phidgetlist.cpp
 */

#include <stdio.h>
#include <unistd.h>
#include "phidget21.h"

int display_devices(CPhidgetManagerHandle phidm)
{
	int serialNo, version, numDevices, i;
	const char* ptr;
	CPhidgetHandle *devices;
	
	CPhidgetManager_getAttachedDevices (phidm, &devices, &numDevices);
	
	printf("%-4s%-38s%16s%10s\n","#","Device Name","Serial Number","Version");
	
	
	for(i = 0; i < numDevices; i++)
	{
		CPhidget_getDeviceName(devices[i], &ptr);
		CPhidget_getSerialNumber(devices[i], &serialNo);
		CPhidget_getDeviceVersion(devices[i], &version);
		
		printf("%-4d%-46s%8d%10d\n", i, ptr, serialNo, version);
	}
	
	return 0;
}


int main() 
{
	CPhidgetManagerHandle phidm;
	CPhidgetManager_create(&phidm);
	CPhidgetManager_open(phidm);
	
	usleep(300000); //300ms
	display_devices(phidm);
	
	CPhidgetManager_close(phidm);
	CPhidgetManager_delete(phidm);
	return 0;
}
