#############################################################
#
# webif_sbc2
#
#############################################################
WEBIF_SBC2_VERSION:=0.2
WEBIF_SBC2_SOURCE:=package/webif_sbc2
WEBIF_SBC2_SITE:=
WEBIF_SBC2_DIR:=$(BUILD_DIR)/webif_sbc2-$(WEBIF_SBC2_VERSION)

$(WEBIF_SBC2_DIR)/.unpacked:
	mkdir -p $(WEBIF_SBC2_DIR)
	touch $@

$(WEBIF_SBC2_DIR)/.built: $(WEBIF_SBC2_DIR)/.unpacked
	$(TARGET_CC) $(TARGET_CFLAGS) -o $(WEBIF_SBC2_DIR)/bstrip $(WEBIF_SBC2_SOURCE)/src/bstrip.c
	$(TARGET_CC) $(TARGET_CFLAGS) -o $(WEBIF_SBC2_DIR)/simplereboot $(WEBIF_SBC2_SOURCE)/src/simplereboot.c
	$(STRIPCMD) --strip-unneeded $(WEBIF_SBC2_DIR)/bstrip $(WEBIF_SBC2_DIR)/simplereboot
	touch $@

$(TARGET_DIR)/www/cgi-bin/.categories: $(WEBIF_SBC2_DIR)/.built
	mkdir -p $(TARGET_DIR)/etc
	mkdir -p $(TARGET_DIR)/usr/lib
	mkdir -p $(TARGET_DIR)/usr/lib/webif
	mkdir -p $(TARGET_DIR)/www
	mkdir -p $(TARGET_DIR)/www/images
	mkdir -p $(TARGET_DIR)/www/images/phidgets
	mkdir -p $(TARGET_DIR)/www/js
	mkdir -p $(TARGET_DIR)/www/css
	mkdir -p $(TARGET_DIR)/www/cgi-bin
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/usr/lib/webif/*.sh $(TARGET_DIR)/usr/lib/webif
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/usr/lib/webif/*.awk $(TARGET_DIR)/usr/lib/webif
	$(INSTALL) -m0755 $(WEBIF_SBC2_DIR)/bstrip $(TARGET_DIR)/usr/bin/
	$(INSTALL) -m0755 $(WEBIF_SBC2_DIR)/simplereboot $(TARGET_DIR)/usr/bin/
	cp -dpf $(WEBIF_SBC2_SOURCE)/files/www/index.html $(TARGET_DIR)/www/
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/webif.js $(TARGET_DIR)/www/
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/favicon.ico $(TARGET_DIR)/www/
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/css/*.* $(TARGET_DIR)/www/css
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/js/*.* $(TARGET_DIR)/www/js
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/images/*.* $(TARGET_DIR)/www/images
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/images/phidgets/*.* $(TARGET_DIR)/www/images/phidgets
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/cgi-bin/*.sh $(TARGET_DIR)/www/cgi-bin
	cp -dpfr $(WEBIF_SBC2_SOURCE)/files/www/cgi-bin/.categories $(TARGET_DIR)/www/cgi-bin
	@if [ ! -f $(TARGET_DIR)/etc/banner ]; then	\
		ln -sf issue $(TARGET_DIR)/etc/banner;	\
	fi
	touch $@

webif_sbc2: busybox $(TARGET_DIR)/www/cgi-bin/.categories

webif_sbc2-clean:
	rm -f $(TARGET_DIR)/www/cgi-bin/webif/* $(TARGET_DIR)/www/webif.*
	rm -rf $(TARGET_DIR)/usr/lib/webif
	rm -f $(TARGET_DIR)/usr/bin/bstrip $(TARGET_DIR)/usr/bin/simplereboot
	rm -f $(WEBIF_SBC2_DIR)/bstrip $(WEBIF_SBC2_DIR)/simplereboot $(WEBIF_SBC2_DIR)/.built

webif_sbc2-source:

webif_sbc2-dirclean:
	rm -rf $(WEBIF_SBC2_DIR)
#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_WEBIF_SBC2)),y)
TARGETS+=webif_sbc2
endif
